/**
 * GENERATED FILE - DO NOT EDIT
 *
 */

package org.richfaces.component.html;

import org.richfaces.component.UIPaint2D ;
import javax.faces.convert.Converter ;
import java.lang.Object ;
import java.lang.String ;
import javax.faces.el.MethodBinding ;

import javax.faces.context.FacesContext;
import javax.faces.el.ValueBinding;

/**
 * Component-Type org.richfaces.Paint2D
 * Component-Family javax.faces.Output
  	 * Renderer-Type org.richfaces.Paint2DRenderer
  	 * Create an image by paint in a managed bean, same as paint (Graphics g) in SWING components.
		 	It can be used as a cacheable or non-cacheable resource. With a cache support, a key is created in URI
		 	with a mix of size (width/height), paint method, format and data attributes.
 */
 public class HtmlPaint2D extends org.richfaces.component.UIPaint2D {

  public static final String COMPONENT_TYPE = "org.richfaces.Paint2D";

  /**
   *  Constructor to init default renderers 
   */ 
  public HtmlPaint2D (){
  	  	setRendererType("org.richfaces.Paint2DRenderer");
  	  }

// Component properties fields
 	/**
	 * hspace
	 * Deprecated. This attribute specifies the amount of white space to be inserted to the left and right of an IMG, APPLET, or OBJECT. The default value is not specified, but is generally a small, non-zero length
	 */
	 	 private String  _hspace = null; /* Default is null*/
	 	  	/**
	 * width
	 * Width in pixels of image (for paint canvas and HTML attribute)
	 */
	 	 private int  _width = 10;		
	/**
	 * Flag indicated what width is set.
	 */
	 private boolean _widthSet = false;	
	 	  	/**
	 * styleClass
	 * Corresponds to the HTML class attribute
	 */
	 	 private String  _styleClass = null; /* Default is null*/
	 	  	/**
	 * align
	 * bottom|middle|top|left|right
            Deprecated. This attribute specifies the position of an IMG, OBJECT, or APPLET with respect to its context.
            
            The following values for align concern the object's position with respect to surrounding text:
            
            * bottom: means that the bottom of the object should be vertically aligned with the current baseline. This is the default value.
            * middle: means that the center of the object should be vertically aligned with the current baseline.
            * top: means that the top of the object should be vertically aligned with the top of the current text line
	 */
	 	 private String  _align = null; /* Default is null*/
	 	  	/**
	 * data
	 * Value calculated at render time and stored in Image URI (as part of cache Key), 
			at paint time passed to a paint method. It can be used for updating cache at change of image generating
			conditions, and for creating paint beans as "Lightweight" pattern components (request scope).
			IMPORTANT: Since serialized data stored in URI, avoid using big objects.
	 */
	 	 private Object  _data = null; /* Default is null*/
	 	  	/**
	 * paint
	 * The method calls expression to paint Image on prepared Buffered image. It must have two parameters with a type of java.awt.Graphics2D (graphics to paint) and Object (restored from URI "data" property).
			For painting used 32-bit RGBA color model (for 8-bit images used Diffusion filtration before sending).
	 */
	 	 private MethodBinding  _paint = null; /* Default is null*/
	 	  	/**
	 * format
	 * format Name of format for sending a generated image. It currently supports "jpeg" (24 bit, default), "gif" (8 bit with transparency), "png" (32 bit with transparency)
	 */
	 	 private String  _format = null; /* Default is null*/
	 	   	/**
	 * lang
	 * Code describing the language used in the generated markup for this component
	 */
	 	 private String  _lang = null; /* Default is null*/
	 	  	/**
	 * bgcolor
	 * Background color of painted image. Default value is 'transparent' which means no background fill. 
			Hex colors can be used, as well as common color names. 
			Invalid values are treated as transparent.
			Note, that JPEG format doesn't support transparency, and transparent background is painted black.
			Also note, that several browsers (e.g. IE6) do not support PNG transparency.
	 */
	 	 private String  _bgcolor = null; /* Default is "transparent"*/
	 	    	/**
	 * title
	 * Advisory title information about markup elements generated for this component
	 */
	 	 private String  _title = null; /* Default is null*/
	 	  	/**
	 * height
	 * Height in pixels of image (for paint canvas and HTML attribute)
	 */
	 	 private int  _height = 10;		
	/**
	 * Flag indicated what height is set.
	 */
	 private boolean _heightSet = false;	
	 	  	/**
	 * style
	 * CSS style(s) is/are to be applied when this component is rendered
	 */
	 	 private String  _style = null; /* Default is null*/
	 	  	/**
	 * dir
	 * Direction indication for text that does not inherit
						directionality. Valid values are "LTR" (left-to-right)
						and "RTL" (right-to-left)
	 */
	 	 private String  _dir = null; /* Default is null*/
	 	  	/**
	 * converter
	 * Id of Converter to be used or reference to a Converter
	 */
	 	 private Converter  _converter = null; /* Default is null*/
	 	  	/**
	 * value
	 * The initial value to set when rendered for the first time
	 */
	 	 private Object  _value = null; /* Default is null*/
	 	   	/**
	 * border
	 * Deprecated. This attribute specifies the width of an IMG or OBJECT border, in pixels. The default value for this attribute depends on the user agent
	 */
	 	 private String  _border = null; /* Default is null*/
	 	  	/**
	 * vspace
	 * Deprecated. This attribute specifies the amount of white space to be inserted above and below an IMG, APPLET, or OBJECT. The default value is not specified, but is generally a small, non-zero length
	 */
	 	 private String  _vspace = null; /* Default is null*/
	 	  	/**
	 * cacheable
	 * Supported (or not) client/server caching for generated images.
			Caching on client supported by properly sending and processing of HTTP headers (Last-Modified, Expires, If-Modified-Since, etc.)
			Server-side caching is supported by application-scope object cache.
			For build of cache key use "value" attribute, serialized to URI.
	 */
	 	 private boolean  _cacheable = false;		
	/**
	 * Flag indicated what cacheable is set.
	 */
	 private boolean _cacheableSet = false;	
	 	 
// Getters-setters
    /**
	 * Deprecated. This attribute specifies the amount of white space to be inserted to the left and right of an IMG, APPLET, or OBJECT. The default value is not specified, but is generally a small, non-zero length
	 * Setter for hspace
	 * @param hspace - new value
	 */
	 public void setHspace( String  __hspace ){
		this._hspace = __hspace;
	 	 }


   /**
	 * Deprecated. This attribute specifies the amount of white space to be inserted to the left and right of an IMG, APPLET, or OBJECT. The default value is not specified, but is generally a small, non-zero length
	 * Getter for hspace
	 * @return hspace value from local variable or value bindings
	 */
	 public String getHspace(  ){
	         if (null != this._hspace)
        {
            return this._hspace;
        	    }
        ValueBinding vb = getValueBinding("hspace");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	      /**
	 * Width in pixels of image (for paint canvas and HTML attribute)
	 * Setter for width
	 * @param width - new value
	 */
	 public void setWidth( int  __width ){
		this._width = __width;
	 		this._widthSet = true;
	 	 }


   /**
	 * Width in pixels of image (for paint canvas and HTML attribute)
	 * Getter for width
	 * @return width value from local variable or value bindings
	 */
	 public int getWidth(  ){
	 		 if(this._widthSet){
			return this._width;
		 }
    	ValueBinding vb = getValueBinding("width");
    	if (vb != null) {
    	    Integer value = (Integer) vb.getValue(getFacesContext());
    	    if (null == value) {
    			return this._width;
    	    }
    	    return (value.intValue());
    	} else {
    	    return (this._width);
    	}
	 	 }
	      /**
	 * Corresponds to the HTML class attribute
	 * Setter for styleClass
	 * @param styleClass - new value
	 */
	 public void setStyleClass( String  __styleClass ){
		this._styleClass = __styleClass;
	 	 }


   /**
	 * Corresponds to the HTML class attribute
	 * Getter for styleClass
	 * @return styleClass value from local variable or value bindings
	 */
	 public String getStyleClass(  ){
	         if (null != this._styleClass)
        {
            return this._styleClass;
        	    }
        ValueBinding vb = getValueBinding("styleClass");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	      /**
	 * bottom|middle|top|left|right
            Deprecated. This attribute specifies the position of an IMG, OBJECT, or APPLET with respect to its context.
            
            The following values for align concern the object's position with respect to surrounding text:
            
            * bottom: means that the bottom of the object should be vertically aligned with the current baseline. This is the default value.
            * middle: means that the center of the object should be vertically aligned with the current baseline.
            * top: means that the top of the object should be vertically aligned with the top of the current text line
	 * Setter for align
	 * @param align - new value
	 */
	 public void setAlign( String  __align ){
		this._align = __align;
	 	 }


   /**
	 * bottom|middle|top|left|right
            Deprecated. This attribute specifies the position of an IMG, OBJECT, or APPLET with respect to its context.
            
            The following values for align concern the object's position with respect to surrounding text:
            
            * bottom: means that the bottom of the object should be vertically aligned with the current baseline. This is the default value.
            * middle: means that the center of the object should be vertically aligned with the current baseline.
            * top: means that the top of the object should be vertically aligned with the top of the current text line
	 * Getter for align
	 * @return align value from local variable or value bindings
	 */
	 public String getAlign(  ){
	         if (null != this._align)
        {
            return this._align;
        	    }
        ValueBinding vb = getValueBinding("align");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	      /**
	 * Value calculated at render time and stored in Image URI (as part of cache Key), 
			at paint time passed to a paint method. It can be used for updating cache at change of image generating
			conditions, and for creating paint beans as "Lightweight" pattern components (request scope).
			IMPORTANT: Since serialized data stored in URI, avoid using big objects.
	 * Setter for data
	 * @param data - new value
	 */
	 public void setData( Object  __data ){
		this._data = __data;
	 	 }


   /**
	 * Value calculated at render time and stored in Image URI (as part of cache Key), 
			at paint time passed to a paint method. It can be used for updating cache at change of image generating
			conditions, and for creating paint beans as "Lightweight" pattern components (request scope).
			IMPORTANT: Since serialized data stored in URI, avoid using big objects.
	 * Getter for data
	 * @return data value from local variable or value bindings
	 */
	 public Object getData(  ){
	         if (null != this._data)
        {
            return this._data;
        	    }
        ValueBinding vb = getValueBinding("data");
        if (null != vb){
            return (Object)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	      /**
	 * The method calls expression to paint Image on prepared Buffered image. It must have two parameters with a type of java.awt.Graphics2D (graphics to paint) and Object (restored from URI "data" property).
			For painting used 32-bit RGBA color model (for 8-bit images used Diffusion filtration before sending).
	 * Setter for paint
	 * @param paint - new value
	 */
	 public void setPaint( MethodBinding  __paint ){
		this._paint = __paint;
	 	 }


   /**
	 * The method calls expression to paint Image on prepared Buffered image. It must have two parameters with a type of java.awt.Graphics2D (graphics to paint) and Object (restored from URI "data" property).
			For painting used 32-bit RGBA color model (for 8-bit images used Diffusion filtration before sending).
	 * Getter for paint
	 * @return paint value from local variable or value bindings
	 */
	 public MethodBinding getPaint(  ){
	         if (null != this._paint)
        {
            return this._paint;
                } else {
            return null;
        }
	 	 }
	      /**
	 * format Name of format for sending a generated image. It currently supports "jpeg" (24 bit, default), "gif" (8 bit with transparency), "png" (32 bit with transparency)
	 * Setter for format
	 * @param format - new value
	 */
	 public void setFormat( String  __format ){
		this._format = __format;
	 	 }


   /**
	 * format Name of format for sending a generated image. It currently supports "jpeg" (24 bit, default), "gif" (8 bit with transparency), "png" (32 bit with transparency)
	 * Getter for format
	 * @return format value from local variable or value bindings
	 */
	 public String getFormat(  ){
	         if (null != this._format)
        {
            return this._format;
        	    }
        ValueBinding vb = getValueBinding("format");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	       /**
	 * Code describing the language used in the generated markup for this component
	 * Setter for lang
	 * @param lang - new value
	 */
	 public void setLang( String  __lang ){
		this._lang = __lang;
	 	 }


   /**
	 * Code describing the language used in the generated markup for this component
	 * Getter for lang
	 * @return lang value from local variable or value bindings
	 */
	 public String getLang(  ){
	         if (null != this._lang)
        {
            return this._lang;
        	    }
        ValueBinding vb = getValueBinding("lang");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	      /**
	 * Background color of painted image. Default value is 'transparent' which means no background fill. 
			Hex colors can be used, as well as common color names. 
			Invalid values are treated as transparent.
			Note, that JPEG format doesn't support transparency, and transparent background is painted black.
			Also note, that several browsers (e.g. IE6) do not support PNG transparency.
	 * Setter for bgcolor
	 * @param bgcolor - new value
	 */
	 public void setBgcolor( String  __bgcolor ){
		this._bgcolor = __bgcolor;
	 	 }


   /**
	 * Background color of painted image. Default value is 'transparent' which means no background fill. 
			Hex colors can be used, as well as common color names. 
			Invalid values are treated as transparent.
			Note, that JPEG format doesn't support transparency, and transparent background is painted black.
			Also note, that several browsers (e.g. IE6) do not support PNG transparency.
	 * Getter for bgcolor
	 * @return bgcolor value from local variable or value bindings
	 */
	 public String getBgcolor(  ){
	         if (null != this._bgcolor)
        {
            return this._bgcolor;
        	    }
        ValueBinding vb = getValueBinding("bgcolor");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return "transparent";
        }
	 	 }
	        /**
	 * Advisory title information about markup elements generated for this component
	 * Setter for title
	 * @param title - new value
	 */
	 public void setTitle( String  __title ){
		this._title = __title;
	 	 }


   /**
	 * Advisory title information about markup elements generated for this component
	 * Getter for title
	 * @return title value from local variable or value bindings
	 */
	 public String getTitle(  ){
	         if (null != this._title)
        {
            return this._title;
        	    }
        ValueBinding vb = getValueBinding("title");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	      /**
	 * Height in pixels of image (for paint canvas and HTML attribute)
	 * Setter for height
	 * @param height - new value
	 */
	 public void setHeight( int  __height ){
		this._height = __height;
	 		this._heightSet = true;
	 	 }


   /**
	 * Height in pixels of image (for paint canvas and HTML attribute)
	 * Getter for height
	 * @return height value from local variable or value bindings
	 */
	 public int getHeight(  ){
	 		 if(this._heightSet){
			return this._height;
		 }
    	ValueBinding vb = getValueBinding("height");
    	if (vb != null) {
    	    Integer value = (Integer) vb.getValue(getFacesContext());
    	    if (null == value) {
    			return this._height;
    	    }
    	    return (value.intValue());
    	} else {
    	    return (this._height);
    	}
	 	 }
	      /**
	 * CSS style(s) is/are to be applied when this component is rendered
	 * Setter for style
	 * @param style - new value
	 */
	 public void setStyle( String  __style ){
		this._style = __style;
	 	 }


   /**
	 * CSS style(s) is/are to be applied when this component is rendered
	 * Getter for style
	 * @return style value from local variable or value bindings
	 */
	 public String getStyle(  ){
	         if (null != this._style)
        {
            return this._style;
        	    }
        ValueBinding vb = getValueBinding("style");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	      /**
	 * Direction indication for text that does not inherit
						directionality. Valid values are "LTR" (left-to-right)
						and "RTL" (right-to-left)
	 * Setter for dir
	 * @param dir - new value
	 */
	 public void setDir( String  __dir ){
		this._dir = __dir;
	 	 }


   /**
	 * Direction indication for text that does not inherit
						directionality. Valid values are "LTR" (left-to-right)
						and "RTL" (right-to-left)
	 * Getter for dir
	 * @return dir value from local variable or value bindings
	 */
	 public String getDir(  ){
	         if (null != this._dir)
        {
            return this._dir;
        	    }
        ValueBinding vb = getValueBinding("dir");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	      /**
	 * Id of Converter to be used or reference to a Converter
	 * Setter for converter
	 * @param converter - new value
	 */
	 public void setConverter( Converter  __converter ){
		this._converter = __converter;
	 	 }


   /**
	 * Id of Converter to be used or reference to a Converter
	 * Getter for converter
	 * @return converter value from local variable or value bindings
	 */
	 public Converter getConverter(  ){
	         if (null != this._converter)
        {
            return this._converter;
        	    }
        ValueBinding vb = getValueBinding("converter");
        if (null != vb){
            return (Converter)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	      /**
	 * The initial value to set when rendered for the first time
	 * Setter for value
	 * @param value - new value
	 */
	 public void setValue( Object  __value ){
		this._value = __value;
	 	 }


   /**
	 * The initial value to set when rendered for the first time
	 * Getter for value
	 * @return value value from local variable or value bindings
	 */
	 public Object getValue(  ){
	         if (null != this._value)
        {
            return this._value;
        	    }
        ValueBinding vb = getValueBinding("value");
        if (null != vb){
            return (Object)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	       /**
	 * Deprecated. This attribute specifies the width of an IMG or OBJECT border, in pixels. The default value for this attribute depends on the user agent
	 * Setter for border
	 * @param border - new value
	 */
	 public void setBorder( String  __border ){
		this._border = __border;
	 	 }


   /**
	 * Deprecated. This attribute specifies the width of an IMG or OBJECT border, in pixels. The default value for this attribute depends on the user agent
	 * Getter for border
	 * @return border value from local variable or value bindings
	 */
	 public String getBorder(  ){
	         if (null != this._border)
        {
            return this._border;
        	    }
        ValueBinding vb = getValueBinding("border");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	      /**
	 * Deprecated. This attribute specifies the amount of white space to be inserted above and below an IMG, APPLET, or OBJECT. The default value is not specified, but is generally a small, non-zero length
	 * Setter for vspace
	 * @param vspace - new value
	 */
	 public void setVspace( String  __vspace ){
		this._vspace = __vspace;
	 	 }


   /**
	 * Deprecated. This attribute specifies the amount of white space to be inserted above and below an IMG, APPLET, or OBJECT. The default value is not specified, but is generally a small, non-zero length
	 * Getter for vspace
	 * @return vspace value from local variable or value bindings
	 */
	 public String getVspace(  ){
	         if (null != this._vspace)
        {
            return this._vspace;
        	    }
        ValueBinding vb = getValueBinding("vspace");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	      /**
	 * Supported (or not) client/server caching for generated images.
			Caching on client supported by properly sending and processing of HTTP headers (Last-Modified, Expires, If-Modified-Since, etc.)
			Server-side caching is supported by application-scope object cache.
			For build of cache key use "value" attribute, serialized to URI.
	 * Setter for cacheable
	 * @param cacheable - new value
	 */
	 public void setCacheable( boolean  __cacheable ){
		this._cacheable = __cacheable;
	 		this._cacheableSet = true;
	 	 }


   /**
	 * Supported (or not) client/server caching for generated images.
			Caching on client supported by properly sending and processing of HTTP headers (Last-Modified, Expires, If-Modified-Since, etc.)
			Server-side caching is supported by application-scope object cache.
			For build of cache key use "value" attribute, serialized to URI.
	 * Getter for cacheable
	 * @return cacheable value from local variable or value bindings
	 */
	 public boolean isCacheable(  ){
	 		 if(this._cacheableSet){
			return this._cacheable;
		 }
    	ValueBinding vb = getValueBinding("cacheable");
    	if (vb != null) {
    	    Boolean value = (Boolean) vb.getValue(getFacesContext());
    	    if (null == value) {
    			return this._cacheable;
    	    }
    	    return (value.booleanValue());
    	} else {
    	    return (this._cacheable);
    	}
	 	 }
	  
// Component family.
	public static final String COMPONENT_FAMILY = "javax.faces.Output";

	public String getFamily() {
		return COMPONENT_FAMILY;
	}

// Save state
// ----------------------------------------------------- StateHolder Methods


    public Object saveState(FacesContext context) {
        Object values[] = new Object[22];
        values[0] = super.saveState(context);
 	 	          values[1] = _hspace;
	   	 	
  	        values[2] = new Integer(_width);
	   	   values[3] = Boolean.valueOf(_widthSet);	
	   	 	
  	 	          values[4] = _styleClass;
	   	 	
  	 	          values[5] = _align;
	   	 	
  	 	          values[6] = _data;
	   	 	
  	 	          values[7] = saveAttachedState(context, _paint );		
	   	 	
  	 	          values[8] = _format;
	   	 	
   	 	          values[9] = _lang;
	   	 	
  	 	          values[10] = _bgcolor;
	   	 	
    	 	          values[11] = _title;
	   	 	
  	        values[12] = new Integer(_height);
	   	   values[13] = Boolean.valueOf(_heightSet);	
	   	 	
  	 	          values[14] = _style;
	   	 	
  	 	          values[15] = _dir;
	   	 	
  	 	          values[16] = saveAttachedState(context, _converter );		
	   	 	
  	 	          values[17] = _value;
	   	 	
   	 	          values[18] = _border;
	   	 	
  	 	          values[19] = _vspace;
	   	 	
  	        values[20] = new Boolean(_cacheable);
	   	   values[21] = Boolean.valueOf(_cacheableSet);	
	   	 	
 	  return values;
   }
   

    public void restoreState(FacesContext context, Object state) {
        Object values[] = (Object[]) state;
        super.restoreState(context, values[0]);
 	 	          _hspace = (String)values[1] ;
	   	 	
  	        _width = ((Integer)values[2]).intValue();
	   	   _widthSet = ((Boolean)values[3]).booleanValue();	
	   	 	
  	 	          _styleClass = (String)values[4] ;
	   	 	
  	 	          _align = (String)values[5] ;
	   	 	
  	 	          _data = (Object)values[6] ;
	   	 	
  	 	          _paint = (MethodBinding)restoreAttachedState(context,values[7] );		
	   	 	
  	 	          _format = (String)values[8] ;
	   	 	
   	 	          _lang = (String)values[9] ;
	   	 	
  	 	          _bgcolor = (String)values[10] ;
	   	 	
    	 	          _title = (String)values[11] ;
	   	 	
  	        _height = ((Integer)values[12]).intValue();
	   	   _heightSet = ((Boolean)values[13]).booleanValue();	
	   	 	
  	 	          _style = (String)values[14] ;
	   	 	
  	 	          _dir = (String)values[15] ;
	   	 	
  	 	          _converter = (Converter)restoreAttachedState(context,values[16] );		
	   	 	
  	 	          _value = (Object)values[17] ;
	   	 	
   	 	          _border = (String)values[18] ;
	   	 	
  	 	          _vspace = (String)values[19] ;
	   	 	
  	        _cacheable = ((Boolean)values[20]).booleanValue();
	   	   _cacheableSet = ((Boolean)values[21]).booleanValue();	
	   	 	
 	
		
	}	
// Utilites

}