/**
 * GENERATED FILE - DO NOT EDIT
 *
 */

package org.richfaces.component.html;

import org.richfaces.component.UIToolBarGroup ;
import java.lang.String ;

import javax.faces.context.FacesContext;
import javax.faces.el.ValueBinding;

/**
 * Component-Type org.richfaces.ToolBarGroup
 * Component-Family org.richfaces.ToolBar
  	 * Renderer-Type org.richfaces.ToolBarGroupRenderer
  	 * A group of items inside a tool bar. The group item
	    is separated basing on the "itemSeparator" attribute. Location of a group
	    on a tool bar is set up with the "location" attribute.
 */
 public class HtmlToolBarGroup extends org.richfaces.component.UIToolBarGroup {

  public static final String COMPONENT_TYPE = "org.richfaces.ToolBarGroup";

  /**
   *  Constructor to init default renderers 
   */ 
  public HtmlToolBarGroup (){
  	  	setRendererType("org.richfaces.ToolBarGroupRenderer");
  	  }

// Component properties fields
   	/**
	 * style
	 * CSS style(s) is/are to be applied when this component is rendered
	 */
	 	 private String  _style = null; /* Default is null*/
	 	  	/**
	 * location
	 * "A location of a group on a tool bar. Possible values are "left" and "right"."
	 */
	 	 private String  _location = null; /* Default is "left"*/
	 	  	/**
	 * styleClass
	 * Corresponds to the HTML class attribute
	 */
	 	 private String  _styleClass = null; /* Default is null*/
	 	     	/**
	 * itemSeparator
	 * "A separator for the items in a group. Possible
	    	values are "none", "line", "square", "disc" and "grid"."
	 */
	 	 private String  _itemSeparator = null; /* Default is "none"*/
	 	  	/**
	 * separatorClass
	 * "A CSS class to be applied to tool bar group separators."
	 */
	 	 private String  _separatorClass = null; /* Default is null*/
	 	 
// Getters-setters
      /**
	 * CSS style(s) is/are to be applied when this component is rendered
	 * Setter for style
	 * @param style - new value
	 */
	 public void setStyle( String  __style ){
		this._style = __style;
	 	 }


   /**
	 * CSS style(s) is/are to be applied when this component is rendered
	 * Getter for style
	 * @return style value from local variable or value bindings
	 */
	 public String getStyle(  ){
	         if (null != this._style)
        {
            return this._style;
        	    }
        ValueBinding vb = getValueBinding("style");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	      /**
	 * "A location of a group on a tool bar. Possible values are "left" and "right"."
	 * Setter for location
	 * @param location - new value
	 */
	 public void setLocation( String  __location ){
		this._location = __location;
	 	 }


   /**
	 * "A location of a group on a tool bar. Possible values are "left" and "right"."
	 * Getter for location
	 * @return location value from local variable or value bindings
	 */
	 public String getLocation(  ){
	         if (null != this._location)
        {
            return this._location;
        	    }
        ValueBinding vb = getValueBinding("location");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return "left";
        }
	 	 }
	      /**
	 * Corresponds to the HTML class attribute
	 * Setter for styleClass
	 * @param styleClass - new value
	 */
	 public void setStyleClass( String  __styleClass ){
		this._styleClass = __styleClass;
	 	 }


   /**
	 * Corresponds to the HTML class attribute
	 * Getter for styleClass
	 * @return styleClass value from local variable or value bindings
	 */
	 public String getStyleClass(  ){
	         if (null != this._styleClass)
        {
            return this._styleClass;
        	    }
        ValueBinding vb = getValueBinding("styleClass");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	         /**
	 * "A separator for the items in a group. Possible
	    	values are "none", "line", "square", "disc" and "grid"."
	 * Setter for itemSeparator
	 * @param itemSeparator - new value
	 */
	 public void setItemSeparator( String  __itemSeparator ){
		this._itemSeparator = __itemSeparator;
	 	 }


   /**
	 * "A separator for the items in a group. Possible
	    	values are "none", "line", "square", "disc" and "grid"."
	 * Getter for itemSeparator
	 * @return itemSeparator value from local variable or value bindings
	 */
	 public String getItemSeparator(  ){
	         if (null != this._itemSeparator)
        {
            return this._itemSeparator;
        	    }
        ValueBinding vb = getValueBinding("itemSeparator");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return "none";
        }
	 	 }
	      /**
	 * "A CSS class to be applied to tool bar group separators."
	 * Setter for separatorClass
	 * @param separatorClass - new value
	 */
	 public void setSeparatorClass( String  __separatorClass ){
		this._separatorClass = __separatorClass;
	 	 }


   /**
	 * "A CSS class to be applied to tool bar group separators."
	 * Getter for separatorClass
	 * @return separatorClass value from local variable or value bindings
	 */
	 public String getSeparatorClass(  ){
	         if (null != this._separatorClass)
        {
            return this._separatorClass;
        	    }
        ValueBinding vb = getValueBinding("separatorClass");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	  
// Component family.
	public static final String COMPONENT_FAMILY = "org.richfaces.ToolBar";

	public String getFamily() {
		return COMPONENT_FAMILY;
	}

// Save state
// ----------------------------------------------------- StateHolder Methods


    public Object saveState(FacesContext context) {
        Object values[] = new Object[6];
        values[0] = super.saveState(context);
   	 	          values[1] = _style;
	   	 	
  	 	          values[2] = _location;
	   	 	
  	 	          values[3] = _styleClass;
	   	 	
     	 	          values[4] = _itemSeparator;
	   	 	
  	 	          values[5] = _separatorClass;
	   	 	
 	  return values;
   }
   

    public void restoreState(FacesContext context, Object state) {
        Object values[] = (Object[]) state;
        super.restoreState(context, values[0]);
   	 	          _style = (String)values[1] ;
	   	 	
  	 	          _location = (String)values[2] ;
	   	 	
  	 	          _styleClass = (String)values[3] ;
	   	 	
     	 	          _itemSeparator = (String)values[4] ;
	   	 	
  	 	          _separatorClass = (String)values[5] ;
	   	 	
 	
		
	}	
// Utilites

}