/**
 * License Agreement.
 *
 *  JBoss RichFaces 3.0 - Ajax4jsf Component Library
 *
 * Copyright (C) 2007  Exadel, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

package org.richfaces.renderkit;

import javax.faces.context.FacesContext;
import javax.servlet.ServletContext;

import org.ajax4jsf.framework.renderer.AjaxComponentRendererBase;
import org.richfaces.component.UIModalPanel;

/**
 * @author Nick Belaevski - nbelaevski@exadel.com
 * created 13.02.2007
 * 
 */
public class ModalPanelRendererBase extends AjaxComponentRendererBase {

	//TODO nick - set sizeA to actual min value
	private static final int sizeA = 10;
	
	protected String[] RESIZERS = new String[] {
		"NWU", "N", "NEU", "NEL", "E",
		"SEU", "SEL", "S", "SWL",
		"SWU",	"W", "NWL"
	};
	
	protected Class getComponentClass() {
		return UIModalPanel.class;
	}

	//TODO nick - add messages
	public void checkOptions(FacesContext context, UIModalPanel panel) {
	    	ServletContext servletContext = (ServletContext)context.getExternalContext().getContext();
		if (panel.getMinHeight() != -1) {
			if (panel.getMinHeight() < sizeA) {
				throw new IllegalArgumentException();
			}
			
			if (panel.getHeight() < panel.getMinHeight()) {
			    panel.setHeight(panel.getMinHeight());
			}
		}

		if (panel.getMinWidth() != -1) {
			if (panel.getMinWidth() < sizeA) {
				throw new IllegalArgumentException();
			}

			if (panel.getWidth() < panel.getMinWidth()) {
			    panel.setWidth(panel.getMinWidth());
			}
		}
	}
	
//	protected String buildOptions(FacesContext context, UIModalPanel panel) {
//		return getOptions(context, panel, getUtils());
//	}
	
	public boolean getRendersChildren() {
		return true;
	}
	
//	public static String getOptions(FacesContext context, UIComponent component, RendererUtils utils) {
//		Map options = new HashMap();
//		
//		
//		UIComponent nestingContainer = (UIComponent) AjaxRendererUtils.findAjaxContainer(context, component);
//		UIComponent nestingForm = AjaxRendererUtils.getNestingForm(component);
//		String formId = nestingForm != null ? nestingForm.getClientId(context) : "";
//		options.put("container", nestingContainer.getClientId(context));
//		options.put("form", formId);
//		
//		Object w = component.getAttributes().get("width");
//		if(w == null || w.toString().trim().length() == 0 || "auto".equals(w)) {
//			w = "-1";
//		} else {
//			w = strip(w);
//		}
//		options.put("width", w);
//
//		Object h = component.getAttributes().get("height");
//		if(h == null || h.toString().trim().length() == 0 || "auto".equals(h)) {
//			h = "-1";
//		} else {
//			h = strip(h);
//		}
//		options.put("height", h);
//
//		Object x = component.getAttributes().get("posx");
//		if(x == null) x = component.getAttributes().get("align");
//		if(x == null || x.toString().trim().length() == 0) {
//			x = "50%";
//		} else {
//			x = strip(x);
//		}
//		if(x.equals("left")) x = "0%";
//		else if(x.equals("center") || x.equals("middle")) x = "50%";
//		else if(x.equals("right")) x = "100%";
//		options.put("posx", x);
//
//		Object y = component.getAttributes().get("posy");
//		if(y == null) y = component.getAttributes().get("valign");
//		if(y == null || y.toString().trim().length() == 0) {
//			y = "50%";
//		} else {
//			y = strip(y);
//		}
//		if(y.equals("top")) y = "0%";
//		else if(y.equals("middle") || y.equals("center")) y = "50%";
//		else if(y.equals("bottom")) y = "100%";
//		options.put("posy", y);
//		
//		w = component.getAttributes().get("maxWidth");
//		if(w == null || w.toString().trim().length() == 0) {
//			w = "-1";
//		} else {
//			w = strip(w);
//		}
//		options.put("maxWidth", w);
//		
//		h = component.getAttributes().get("maxHeight");
//		if(h == null || h.toString().trim().length() == 0) {
//			h = "-1";
//		} else {
//			h = strip(h);
//		}
//		options.put("maxHeight", h);
//
////		if(!UIDialogAction.isServerMode(component) 
////			&& DialogWindowRenderer.isSubmitted(utils, context, component)
////			&& findAncestorForm(context, component) != null) {
////			append(options, "ajax", "true");
////		}
//
//		Object c = component.getAttributes().get("resizable");
//		if(c == null) c = Boolean.TRUE;
//		options.put("resizable", c);
//		
//		c = component.getAttributes().get("float");
//		if(c == null) c = Boolean.TRUE;
//		options.put("_float", c);		
//
//		c = component.getAttributes().get("headerHeight");
//		if(c == null) c = "16px";
//		options.put("headerHeight", c);
//		
//		c = component.getAttributes().get("posFunction");
//		if(c != null) {
//			options.put("posFunction", c);
//		}
//
////		Object posReferenceId = ((UIDialogWindow)component).getExternalPosReferenceId();
////		if(posReferenceId == null) posReferenceId = ((UIDialogWindow)component).getPosReferenceId();
////		if(posReferenceId != null) {
////			append(options, "posReferenceId", posReferenceId);
////		}
////		
//		c = component.getAttributes().get("hideParentDialog");
//		if(c == null) c = Boolean.FALSE;
//		options.put("hideParentDialog", c);		
//
//		return ScriptUtils.toScript(options);
//	}
//	
//	static String strip(Object value) {
//		String v = value.toString().trim();
//		if(v.endsWith("px")) return v.substring(0, v.length() - 2);
//		return v;
//	}
}
